new file mode 100755
@@ -0,0 +1,176 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Chandan Babu R. All Rights Reserved.
+#
+# FS QA Test 525
+#
+# Verify that XFS does not cause inode fork's extent count to overflow when
+# Adding/removing xattrs.
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+. ./common/inject
+. ./common/populate
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs xfs
+_require_scratch
+_require_attrs
+_require_xfs_debug
+_require_test_program "punch-alternating"
+_require_xfs_io_error_injection "reduce_max_iextents"
+_require_xfs_io_error_injection "bmap_alloc_minlen_extent"
+
+echo "Format and mount fs"
+_scratch_mkfs_sized $((1024 * 1024 * 1024)) >> $seqres.full
+_scratch_mount >> $seqres.full
+
+bsize=$(_get_block_size $SCRATCH_MNT)
+
+# To be able to remove xattr entries in a situation where inserting new xattrs
+# is prevented due to possible extent count overflow , each xattr insert
+# operation should reserve an extent count for deletion of maximum sized xattr
+# apart from the extent count required for the xattr insert operation being
+# performed.
+#
+# The following table gives an estimation of the total extent count that needs
+# to be reserved for maximum sized "local" xattr insert operation for various
+# block sizes,
+#
+# |-------+----------------------------------------+----------------------------------|
+# | Block | Worst case remove extent count | Total extent |
+# | size | (XFS_DA_NODE_MAXDEPTH + (64k / bsize)) | count |
+# | | | (Xattr insert extent count (6) + |
+# | | | Worst case remove extent count) |
+# |-------+----------------------------------------+----------------------------------|
+# | 1024 | 69 | 75 |
+# | 2048 | 37 | 43 |
+# | 4096 | 22 | 28 |
+# | 32768 | 7 | 13 |
+# | 65536 | 6 | 12 |
+# |-------+----------------------------------------+----------------------------------|
+# Note: Xattr insert extent count = XFS_DA_NODE_MAXDEPTH + 1 = 6.
+#
+# 35 (which is > 28) has been chosen as the pseudo maximum extent count in the
+# XFS kernel module. Hence xattr tests are limited to block sizes >= 4k.
+
+if (( $bsize < 4096 )); then
+ _notrun "FSB size ($bsize) is less than 4k"
+fi
+
+attr_len=255
+
+testfile=$SCRATCH_MNT/testfile
+
+echo "Consume free space"
+fillerdir=$SCRATCH_MNT/fillerdir
+nr_free_blks=$(stat -f -c '%f' $SCRATCH_MNT)
+nr_free_blks=$((nr_free_blks * 90 / 100))
+
+_fill_fs $((bsize * nr_free_blks)) $fillerdir $bsize 0 >> $seqres.full 2>&1
+
+echo "Create fragmented filesystem"
+for dentry in $(ls -1 $fillerdir/); do
+ $here/src/punch-alternating $fillerdir/$dentry >> $seqres.full
+done
+
+echo "Inject reduce_max_iextents error tag"
+_scratch_inject_error reduce_max_iextents 1
+
+echo "Inject bmap_alloc_minlen_extent error tag"
+_scratch_inject_error bmap_alloc_minlen_extent 1
+
+echo "* Set xattrs"
+
+echo "Create \$testfile"
+touch $testfile
+
+echo "Create xattrs"
+nr_attrs=$((bsize * 45 / attr_len))
+for i in $(seq 1 $nr_attrs); do
+ attr="$(printf "trusted.%0247d" $i)"
+ $SETFATTR_PROG -n "$attr" $testfile >> $seqres.full 2>&1
+ [[ $? != 0 ]] && break
+done
+
+echo "Verify \$testfile's naextent count"
+
+naextents=$($XFS_IO_PROG -f -c 'stat' $testfile | grep naextents)
+naextents=${naextents##fsxattr.naextents = }
+if (( $naextents > 35 )); then
+ echo "Extent count overflow check failed: naextents = $naextents"
+ exit 1
+fi
+
+echo "Remove one xattr"
+attr="$(printf "trusted.%0247d" 1)"
+$SETFATTR_PROG -x "$attr" $testfile
+
+echo "Remove \$testfile"
+rm $testfile
+
+echo "* Remove xattrs"
+
+echo "Create \$testfile"
+touch $testfile
+
+echo "Disable reduce_max_iextents error tag"
+_scratch_inject_error reduce_max_iextents 0
+
+echo "Create initial xattr extents"
+
+naextents=0
+last=""
+start=1
+nr_attrs=$((bsize / attr_len))
+
+while (( $naextents < 30 )); do
+ end=$((start + nr_attrs - 1))
+
+ for i in $(seq $start $end); do
+ attr="$(printf "trusted.%0247d" $i)"
+ $SETFATTR_PROG -n $attr $testfile
+ done
+
+ start=$((end + 1))
+
+ naextents=$($XFS_IO_PROG -f -c 'stat' $testfile | grep naextents)
+ naextents=${naextents##fsxattr.naextents = }
+done
+
+echo "Inject reduce_max_iextents error tag"
+_scratch_inject_error reduce_max_iextents 1
+
+echo "Remove xattr to trigger -EFBIG"
+attr="$(printf "trusted.%0247d" 1)"
+$SETFATTR_PROG -x "$attr" $testfile >> $seqres.full 2>&1
+if [[ $? == 0 ]]; then
+ echo "Xattr removal succeeded; Should have failed "
+ exit 1
+fi
+
+rm $testfile && echo "Successfully removed \$testfile"
+
+# success, all done
+status=0
+exit
new file mode 100644
@@ -0,0 +1,19 @@
+QA output created by 525
+Format and mount fs
+Consume free space
+Create fragmented filesystem
+Inject reduce_max_iextents error tag
+Inject bmap_alloc_minlen_extent error tag
+* Set xattrs
+Create $testfile
+Create xattrs
+Verify $testfile's naextent count
+Remove one xattr
+Remove $testfile
+* Remove xattrs
+Create $testfile
+Disable reduce_max_iextents error tag
+Create initial xattr extents
+Inject reduce_max_iextents error tag
+Remove xattr to trigger -EFBIG
+Successfully removed $testfile
@@ -522,6 +522,7 @@
522 auto quick quota
523 auto quick realtime growfs
524 auto quick punch zero insert collapse
+525 auto quick attr
758 auto quick rw attr realtime
759 auto quick rw realtime
760 auto quick rw collapse punch insert zero prealloc
This test verifies that XFS does not cause inode fork's extent count to overflow when adding/removing xattrs. Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com> --- tests/xfs/525 | 176 ++++++++++++++++++++++++++++++++++++++++++++++ tests/xfs/525.out | 19 +++++ tests/xfs/group | 1 + 3 files changed, 196 insertions(+) create mode 100755 tests/xfs/525 create mode 100644 tests/xfs/525.out